
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>A. Wave analysis - Bilbao Exterior Buoy &#8212; Waves, swells and sea level</title>
    
  <link href="../../../_static/css/theme.css" rel="stylesheet">
  <link href="../../../_static/css/index.ff1ffe594081f20da1ef19478df9384b.css" rel="stylesheet">

    
  <link rel="stylesheet"
    href="../../../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../../../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../../../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../../../_static/sphinx-book-theme.css?digest=c3fdc42140077d1ad13ad2f1588a4309" />
    <link rel="stylesheet" type="text/css" href="../../../_static/togglebutton.css" />
    <link rel="stylesheet" type="text/css" href="../../../_static/copybutton.css" />
    <link rel="stylesheet" type="text/css" href="../../../_static/mystnb.css" />
    <link rel="stylesheet" type="text/css" href="../../../_static/sphinx-thebe.css" />
    <link rel="stylesheet" type="text/css" href="../../../_static/panels-main.c949a650a448cc0ae9fd3441c0e17fb0.css" />
    <link rel="stylesheet" type="text/css" href="../../../_static/panels-variables.06eb56fa6e07937060861dad626602ad.css" />
    
  <link rel="preload" as="script" href="../../../_static/js/index.be7d3bbb2ef33a8344ce.js">

    <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
    <script src="../../../_static/jquery.js"></script>
    <script src="../../../_static/underscore.js"></script>
    <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/togglebutton.js"></script>
    <script src="../../../_static/clipboard.min.js"></script>
    <script src="../../../_static/copybutton.js"></script>
    <script>var togglebuttonSelector = '.toggle, .admonition.dropdown, .tag_hide_input div.cell_input, .tag_hide-input div.cell_input, .tag_hide_output div.cell_output, .tag_hide-output div.cell_output, .tag_hide_cell.cell, .tag_hide-cell.cell';</script>
    <script src="../../../_static/sphinx-book-theme.d59cb220de22ca1c485ebbdc042f0030.js"></script>
    <script defer="defer" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script>window.MathJax = {"options": {"processHtmlClass": "tex2jax_process|mathjax_process|math|output_area"}}</script>
    <script async="async" src="https://unpkg.com/thebe@0.5.1/lib/index.js"></script>
    <script>
        const thebe_selector = ".thebe"
        const thebe_selector_input = "pre"
        const thebe_selector_output = ".output"
    </script>
    <script async="async" src="../../../_static/sphinx-thebe.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="A. Wave analysis - Terschelling (Netherlands)" href="Terschelling.html" />
    <link rel="prev" title="A. Wave analysis - Majuro Atoll (Republic of the Marshall Islands)" href="MajuroAtoll.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="None">
    

    <!-- Google Analytics -->
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    

    <div class="container-xl">
      <div class="row">
          
<div class="col-12 col-md-3 bd-sidebar site-navigation show" id="site-navigation">
    
        <div class="navbar-brand-box">
    <a class="navbar-brand text-wrap" href="../../../index.html">
      
        <!-- `logo` is deprecated in Sphinx 4.0, so remove this when we stop supporting 3 -->
        
      
      
      <img src="../../../_static/logoUC.png" class="logo" alt="logo">
      
      
      <h1 class="site-logo" id="site-title">Waves, swells and sea level</h1>
      
    </a>
</div><form class="bd-search d-flex align-items-center" action="../../../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Buscar este libro ..." aria-label="Buscar este libro ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main">
    <div class="bd-toc-item active">
        <ul class="nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="../../../contents/index.html">
   Introduction
  </a>
 </li>
</ul>
<p aria-level="2" class="caption" role="heading">
 <span class="caption-text">
  A. Wave Analysis
 </span>
</p>
<ul class="current nav bd-sidenav">
 <li class="toctree-l1 current active has-children">
  <a class="reference internal" href="A1_Observations.html">
   A.1. Observations
  </a>
  <input checked="" class="toctree-checkbox" id="toctree-checkbox-1" name="toctree-checkbox-1" type="checkbox"/>
  <label for="toctree-checkbox-1">
   <i class="fas fa-chevron-down">
   </i>
  </label>
  <ul class="current">
   <li class="toctree-l2">
    <a class="reference internal" href="MajuroAtoll.html">
     A. Wave analysis - Majuro Atoll (Republic of the Marshall Islands)
    </a>
   </li>
   <li class="toctree-l2 current active">
    <a class="current reference internal" href="#">
     A. Wave analysis - Bilbao Exterior Buoy
    </a>
   </li>
   <li class="toctree-l2">
    <a class="reference internal" href="Terschelling.html">
     A. Wave analysis - Terschelling (Netherlands)
    </a>
   </li>
  </ul>
 </li>
 <li class="toctree-l1 has-children">
  <a class="reference internal" href="../A2_Spectral_Analysis/A2_Spectral_Analysis.html">
   A2 Spectral Analysis
  </a>
  <input class="toctree-checkbox" id="toctree-checkbox-2" name="toctree-checkbox-2" type="checkbox"/>
  <label for="toctree-checkbox-2">
   <i class="fas fa-chevron-down">
   </i>
  </label>
  <ul>
   <li class="toctree-l2">
    <a class="reference internal" href="../A2_Spectral_Analysis/Pierson_Moskovitz_Spectra.html">
     Pierson and Moskowitz (1964), OTD
    </a>
   </li>
   <li class="toctree-l2">
    <a class="reference internal" href="../A2_Spectral_Analysis/JonswapSpectra.html">
     Jonswap Spectra
    </a>
   </li>
   <li class="toctree-l2">
    <a class="reference internal" href="../A2_Spectral_Analysis/DirectionalSpectra.html">
     Directional Spectra
    </a>
   </li>
   <li class="toctree-l2">
    <a class="reference internal" href="../A2_Spectral_Analysis/WaterLevel_from_Spectra.html">
     Water level from Spectra
    </a>
   </li>
   <li class="toctree-l2">
    <a class="reference internal" href="../A2_Spectral_Analysis/FreeSurface_from_DirectionalSpectra.html">
     Free Surface from Directional Spectra
    </a>
   </li>
  </ul>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="../A3_Short-term_Statistics/A3_Short-term_Statistics.html">
   A.3 Short-term statistics
  </a>
 </li>
 <li class="toctree-l1 has-children">
  <a class="reference internal" href="../A4_Wave_Generation/A4_Wave_Generation.html">
   A.4 Wave Generation
  </a>
  <input class="toctree-checkbox" id="toctree-checkbox-3" name="toctree-checkbox-3" type="checkbox"/>
  <label for="toctree-checkbox-3">
   <i class="fas fa-chevron-down">
   </i>
  </label>
  <ul>
   <li class="toctree-l2">
    <a class="reference internal" href="../A4_Wave_Generation/A4_NomogramSPM.html">
     Nomogram Shore Protection Manual - SPM
    </a>
   </li>
  </ul>
 </li>
</ul>
<p aria-level="2" class="caption" role="heading">
 <span class="caption-text">
  B. Wave transformation
 </span>
</p>
<ul class="nav bd-sidenav">
 <li class="toctree-l1 has-children">
  <a class="reference internal" href="../../B_WaveTransformation/B1_Water_Wave_Mechanics/B1_Water_Wave_Mechanics.html">
   B.1 Water Wave Mechanics
  </a>
  <input class="toctree-checkbox" id="toctree-checkbox-4" name="toctree-checkbox-4" type="checkbox"/>
  <label for="toctree-checkbox-4">
   <i class="fas fa-chevron-down">
   </i>
  </label>
  <ul>
   <li class="toctree-l2">
    <a class="reference internal" href="../../B_WaveTransformation/B1_Water_Wave_Mechanics/Potential.html">
     Ecuación del Potencial
    </a>
   </li>
   <li class="toctree-l2">
    <a class="reference internal" href="../../B_WaveTransformation/B1_Water_Wave_Mechanics/Stationary_Wave.html">
     Ecuación del Potencial
    </a>
   </li>
  </ul>
 </li>
 <li class="toctree-l1 has-children">
  <a class="reference internal" href="../../B_WaveTransformation/B2_Monochromatic_Wave_Transformation/B2_Monochromatic_Wave_Transformation.html">
   B2 Monochromatic Wave Transformation
  </a>
  <input class="toctree-checkbox" id="toctree-checkbox-5" name="toctree-checkbox-5" type="checkbox"/>
  <label for="toctree-checkbox-5">
   <i class="fas fa-chevron-down">
   </i>
  </label>
  <ul>
   <li class="toctree-l2">
    <a class="reference internal" href="../../B_WaveTransformation/B2_Monochromatic_Wave_Transformation/DifraccionOblicua.html">
     Ecuación de la Difracción Oblicua
    </a>
   </li>
   <li class="toctree-l2">
    <a class="reference internal" href="../../B_WaveTransformation/B2_Monochromatic_Wave_Transformation/K_dique.html">
     Coeficientes de difracción, refracción y asomeramiento
    </a>
   </li>
  </ul>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="../../B_WaveTransformation/B3_Random_Wave_Transformation/B3_Random_Wave_Transformation.html">
   B.3 Random Wave Transformation
  </a>
 </li>
</ul>
<p aria-level="2" class="caption" role="heading">
 <span class="caption-text">
  C. Long Waves
 </span>
</p>
<ul class="nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="../../C_LongWaves/C1_Surf_Zone_Hydrodynamics/C1_Surf_Zone_Hydrodynamics.html">
   C.1 Surf Zone Hydrodynamics
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="../../C_LongWaves/C2_Long_Waves/C2_Long_Waves.html">
   C.2 Long Waves
  </a>
 </li>
 <li class="toctree-l1 has-children">
  <a class="reference internal" href="../../C_LongWaves/C3_Total_Water_Level/C3_Total_Water_Level.html">
   C.3 Total Water Level
  </a>
  <input class="toctree-checkbox" id="toctree-checkbox-6" name="toctree-checkbox-6" type="checkbox"/>
  <label for="toctree-checkbox-6">
   <i class="fas fa-chevron-down">
   </i>
  </label>
  <ul>
   <li class="toctree-l2">
    <a class="reference internal" href="../../C_LongWaves/C3_Total_Water_Level/GESLA_obtain_AT_TG.html">
     Simulate Astronomical Tide using U-tide library: GESLA database
    </a>
   </li>
   <li class="toctree-l2">
    <a class="reference internal" href="../../C_LongWaves/C3_Total_Water_Level/UHSLC_obtain_AT_TG.html">
     Simulate Astronomical Tide using U-tide library: UHSLC database
    </a>
   </li>
  </ul>
 </li>
</ul>
<p aria-level="2" class="caption" role="heading">
 <span class="caption-text">
  D. Forecast and Hindcast
 </span>
</p>
<ul class="nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="../../D_ForecastAndHindcast/D1_Atmospheric_Forcings.html">
   D.1 Atmospheric Forcings
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="../../D_ForecastAndHindcast/D2_Forecast.html">
   D2. Forecast
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="../../D_ForecastAndHindcast/D3_Hindcast.html">
   D.3 Hindcast
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="../../D_ForecastAndHindcast/D4_Tropical_Cyclones.html">
   D.4 Tropical Cyclones
  </a>
 </li>
</ul>

    </div>
</nav> <!-- To handle the deprecated key -->

<div class="navbar_extra_footer">
  Powered by <a href="https://jupyterbook.org">Jupyter Book</a>
</div>

</div>


          


          
<main class="col py-md-3 pl-md-4 bd-content overflow-auto" role="main">
    
    <div class="topbar container-xl fixed-top">
    <div class="topbar-contents row">
        <div class="col-12 col-md-3 bd-topbar-whitespace site-navigation show"></div>
        <div class="col pl-md-4 topbar-main">
            
            <button id="navbar-toggler" class="navbar-toggler ml-0" type="button" data-toggle="collapse"
                data-toggle="tooltip" data-placement="bottom" data-target=".site-navigation" aria-controls="navbar-menu"
                aria-expanded="true" aria-label="Navegación de palanca" aria-controls="site-navigation"
                title="Navegación de palanca" data-toggle="tooltip" data-placement="left">
                <i class="fas fa-bars"></i>
                <i class="fas fa-arrow-left"></i>
                <i class="fas fa-arrow-up"></i>
            </button>
            
            
<div class="dropdown-buttons-trigger">
    <button id="dropdown-buttons-trigger" class="btn btn-secondary topbarbtn" aria-label="Descarga esta pagina"><i
            class="fas fa-download"></i></button>

    <div class="dropdown-buttons">
        <!-- ipynb file if we had a myst markdown file -->
        
        <!-- Download raw file -->
        <a class="dropdown-buttons" href="../../../_sources/ipynb/A_WaveAnalysis/A1_Observations/BilbaoExt.ipynb"><button type="button"
                class="btn btn-secondary topbarbtn" title="Descargar archivo fuente" data-toggle="tooltip"
                data-placement="left">.ipynb</button></a>
        <!-- Download PDF via print -->
        <button type="button" id="download-print" class="btn btn-secondary topbarbtn" title="Imprimir en PDF"
                onclick="printPdf(this)" data-toggle="tooltip" data-placement="left">.pdf</button>
    </div>
</div>

            <!-- Source interaction buttons -->

            <!-- Full screen (wrap in <a> to have style consistency -->

<a class="full-screen-button"><button type="button" class="btn btn-secondary topbarbtn" data-toggle="tooltip"
        data-placement="bottom" onclick="toggleFullScreen()" aria-label="Modo de pantalla completa"
        title="Modo de pantalla completa"><i
            class="fas fa-expand"></i></button></a>

            <!-- Launch buttons -->

<div class="dropdown-buttons-trigger">
    <button id="dropdown-buttons-trigger" class="btn btn-secondary topbarbtn"
        aria-label="Launch interactive content"><i class="fas fa-rocket"></i></button>
    <div class="dropdown-buttons">
        
        <a class="binder-button" href="https://mybinder.org/v2/gh/executablebooks/jupyter-book/master?urlpath=lab/tree/ipynb/A_WaveAnalysis/A1_Observations/BilbaoExt.ipynb"><button type="button"
                class="btn btn-secondary topbarbtn" title="Lanzamiento Binder" data-toggle="tooltip"
                data-placement="left"><img class="binder-button-logo"
                    src="../../../_static/images/logo_binder.svg"
                    alt="Interact on binder">Binder</button></a>
        
        
        
        
    </div>
</div>

        </div>

        <!-- Table of contents -->
        <div class="d-none d-md-block col-md-2 bd-toc show noprint">
            
            <div class="tocsection onthispage pt-5 pb-3">
                <i class="fas fa-list"></i> Contenido
            </div>
            <nav id="bd-toc-nav" aria-label="Page">
                <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#a-1-observations">
   A.1 Observations
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#a-2-spectral-analysis">
   A.2. Spectral Analysis
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#a-3-short-term-statistics">
   A.3 Short-term statistics
  </a>
  <ul class="nav section-nav flex-column">
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#statistical-parameters">
     Statistical parameters
    </a>
   </li>
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#wave-heigh-distribution">
     Wave Heigh Distribution
    </a>
   </li>
  </ul>
 </li>
</ul>

            </nav>
        </div>
    </div>
</div>
    <div id="main-content" class="row">
        <div class="col-12 col-md-9 pl-md-3 pr-md-0">
            <!-- Table of contents that is only displayed when printing the page -->
            <div id="jb-print-docs-body" class="onlyprint">
                <h1>A. Wave analysis - Bilbao Exterior Buoy</h1>
                <!-- Table of contents -->
                <div id="print-main-content">
                    <div id="jb-print-toc">
                        
                        <div>
                            <h2> Contenido </h2>
                        </div>
                        <nav aria-label="Page">
                            <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#a-1-observations">
   A.1 Observations
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#a-2-spectral-analysis">
   A.2. Spectral Analysis
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#a-3-short-term-statistics">
   A.3 Short-term statistics
  </a>
  <ul class="nav section-nav flex-column">
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#statistical-parameters">
     Statistical parameters
    </a>
   </li>
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#wave-heigh-distribution">
     Wave Heigh Distribution
    </a>
   </li>
  </ul>
 </li>
</ul>

                        </nav>
                    </div>
                </div>
            </div>
            
              <div>
                
  <div class="tex2jax_ignore mathjax_ignore section" id="a-wave-analysis-bilbao-exterior-buoy">
<h1>A. Wave analysis - Bilbao Exterior Buoy<a class="headerlink" href="#a-wave-analysis-bilbao-exterior-buoy" title="Permalink to this headline">¶</a></h1>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># os</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">os.path</span> <span class="k">as</span> <span class="nn">op</span>
<span class="kn">import</span> <span class="nn">sys</span>

<span class="c1"># arrays</span>
<span class="kn">import</span> <span class="nn">math</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span>
<span class="kn">from</span> <span class="nn">scipy.io</span> <span class="kn">import</span> <span class="n">loadmat</span>
<span class="kn">from</span> <span class="nn">scipy</span> <span class="kn">import</span> <span class="n">signal</span> <span class="k">as</span> <span class="n">sg</span>

<span class="c1"># plot</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="k">as</span> <span class="nn">plt</span>

<span class="n">sys</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">getcwd</span><span class="p">()</span>  <span class="p">,</span> <span class="s1">&#39;..&#39;</span><span class="p">,</span> <span class="s1">&#39;..&#39;</span><span class="p">,</span> <span class="s1">&#39;..&#39;</span><span class="p">))</span>

<span class="c1"># dependencies</span>
<span class="kn">from</span> <span class="nn">lib.eta_spec</span> <span class="kn">import</span> <span class="o">*</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">warnings</span>
<span class="n">warnings</span><span class="o">.</span><span class="n">filterwarnings</span><span class="p">(</span><span class="s2">&quot;ignore&quot;</span><span class="p">)</span>
<span class="n">warnings</span><span class="o">.</span><span class="n">simplefilter</span><span class="p">(</span><span class="s1">&#39;ignore&#39;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">RankWarning</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># path to buoy data</span>
<span class="n">p_data</span> <span class="o">=</span> <span class="n">op</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">getcwd</span><span class="p">(),</span><span class="s1">&#39;..&#39;</span><span class="p">,</span> <span class="s1">&#39;..&#39;</span><span class="p">,</span> <span class="s1">&#39;..&#39;</span><span class="p">,</span> <span class="s1">&#39;data&#39;</span><span class="p">,</span> <span class="s1">&#39;Bilbao&#39;</span><span class="p">))</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">file</span> <span class="o">=</span> <span class="s1">&#39;2004_09-15.mat&#39;</span>
<span class="n">mat_file</span> <span class="o">=</span> <span class="n">loadmat</span><span class="p">(</span><span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">p_data</span><span class="p">,</span> <span class="n">file</span><span class="p">))</span>
</pre></div>
</div>
</div>
</div>
<p><strong>Load data</strong></p>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># open .mat files</span>
<span class="sd">&#39;&#39;&#39;</span>
<span class="sd">Metadata:</span>
<span class="sd">L      : </span>
<span class="sd">deltaT : </span>
<span class="sd">eta    :   Water level (mm)</span>
<span class="sd">north  : </span>
<span class="sd">east   : </span>
<span class="sd">Fecha  :   Matlab datenum</span>
<span class="sd">&#39;&#39;&#39;</span>

<span class="n">python_datetime</span> <span class="o">=</span> <span class="p">[</span><span class="n">datetime</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">fromordinal</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">i</span><span class="p">))</span> <span class="o">+</span> <span class="n">datetime</span><span class="o">.</span><span class="n">timedelta</span><span class="p">(</span><span class="n">days</span><span class="o">=</span><span class="n">i</span><span class="o">%</span><span class="k">1</span>) - datetime.timedelta(days = 366) for i in mat_file[&#39;Fecha&#39;][0]]
<span class="n">time</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">to_datetime</span><span class="p">(</span><span class="n">python_datetime</span><span class="p">)</span><span class="o">.</span><span class="n">round</span><span class="p">(</span><span class="s1">&#39;H&#39;</span><span class="p">)</span>
<span class="n">deltaT</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">unique</span><span class="p">(</span><span class="n">mat_file</span><span class="p">[</span><span class="s1">&#39;deltaT&#39;</span><span class="p">])[</span><span class="mi">0</span><span class="p">]</span>

<span class="c1"># load water level series (mm)</span>
<span class="n">watlev</span> <span class="o">=</span> <span class="n">mat_file</span><span class="p">[</span><span class="s1">&#39;eta&#39;</span><span class="p">]</span> <span class="o">/</span> <span class="mi">100</span>
    
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># select the first sea-state (17min)</span>
<span class="n">seastate</span> <span class="o">=</span> <span class="s1">&#39;2005-03-31 04:00:00&#39;</span>
<span class="n">p</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">time</span> <span class="o">==</span> <span class="n">seastate</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
<span class="n">series</span> <span class="o">=</span> <span class="n">watlev</span><span class="p">[</span><span class="n">p</span><span class="p">,:][</span><span class="mi">0</span><span class="p">]</span>
<span class="n">time_series</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">date_range</span><span class="p">(</span><span class="n">start</span><span class="o">=</span><span class="n">seastate</span><span class="p">,</span> <span class="n">end</span><span class="o">=</span><span class="n">datetime</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">strptime</span><span class="p">(</span><span class="n">seastate</span><span class="p">,</span> <span class="s1">&#39;%Y-%m-</span><span class="si">%d</span><span class="s1"> %H:%M:%S&#39;</span><span class="p">)</span> <span class="o">+</span> <span class="n">datetime</span><span class="o">.</span><span class="n">timedelta</span><span class="p">(</span><span class="n">seconds</span><span class="o">=</span><span class="mi">1024</span><span class="p">),</span> <span class="n">freq</span><span class="o">=</span><span class="s1">&#39;S&#39;</span><span class="p">)[:</span><span class="mi">1024</span><span class="p">]</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="a-1-observations">
<h2>A.1 Observations<a class="headerlink" href="#a-1-observations" title="Permalink to this headline">¶</a></h2>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">13</span><span class="p">,</span><span class="mi">4</span><span class="p">))</span>
<span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">time_series</span><span class="p">,</span> <span class="n">series</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;b&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s1">&#39;Time (1s sampling interval)&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s1">&#39;$\eta$ (m)&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">xlim</span><span class="p">([</span><span class="n">time_series</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">time_series</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]])</span>
<span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<img alt="../../../_images/BilbaoExt_10_0.png" src="../../../_images/BilbaoExt_10_0.png" />
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Mean:              &quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">series</span><span class="p">))</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Standar Deviation: &quot;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">var</span><span class="p">(</span><span class="n">series</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output stream highlight-myst-ansi notranslate"><div class="highlight"><pre><span></span>Mean:               -0.0028320312499999795
Standar Deviation:  9.092345495223999
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="a-2-spectral-analysis">
<h2>A.2. Spectral Analysis<a class="headerlink" href="#a-2-spectral-analysis" title="Permalink to this headline">¶</a></h2>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Calculate spectra help(sg.welch)</span>
<span class="n">f</span><span class="p">,</span> <span class="n">E</span> <span class="o">=</span> <span class="n">sg</span><span class="o">.</span><span class="n">welch</span><span class="p">(</span><span class="n">series</span><span class="p">,</span> <span class="n">fs</span> <span class="o">=</span> <span class="mi">1</span><span class="p">,</span> <span class="n">nfft</span> <span class="o">=</span> <span class="mi">1024</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Plot wave spectrum</span>
<span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">5</span><span class="p">,</span><span class="mi">5</span><span class="p">))</span>
<span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">,</span> <span class="n">c</span><span class="o">=</span><span class="s1">&#39;b&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s1">&#39;frequency (Hz)&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s1">&#39;Densidad espectral (/Hz)&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s1">&#39;PSD (m²/Hz)&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<img alt="../../../_images/BilbaoExt_14_0.png" src="../../../_images/BilbaoExt_14_0.png" />
</div>
</div>
<p><strong>Wave spectrum parameters</strong></p>
<p>\begin{equation}
m_{n} = \int_{0}^{\infty}S(\omega)d\omega   ; n=0,1,2…
\end{equation}</p>
<p><span class="math notranslate nohighlight">\(m_{0}:\)</span> zeroth-order moment of the wave spectrum <br>
<span class="math notranslate nohighlight">\(m_{1}:\)</span> first-order moment of the wave spectrum</p>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Momento calculado con el método calc_momento</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Zeroth-order moment:  &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">moment</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)))</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;First-order moment:   &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">moment</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)))</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output stream highlight-myst-ansi notranslate"><div class="highlight"><pre><span></span>Zeroth-order moment:  9.813944518280783
First-order moment:   1.538209247504411
</pre></div>
</div>
</div>
</div>
<br><p>\begin{equation}
H_{m0} = 4.004 \sqrt{m_{0}}
\end{equation}</p>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Wave height of the zeroth order moment</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Wave heigh: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="mf">4.004</span> <span class="o">*</span> <span class="n">math</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">moment</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">))))</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output stream highlight-myst-ansi notranslate"><div class="highlight"><pre><span></span>Wave heigh: 12.54341721940994
</pre></div>
</div>
</div>
</div>
<br><p>\begin{equation}
\overline{\omega}=\frac{m_{1}}{m_{0}}; \overline{T}=2\pi\frac{m_{0}}{m_{1}}; \overline{T_{z}}=2\pi\frac{m_{0}}{m_{2}}
\end{equation}</p>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Mean frequency</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Mean frequency :                          &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">moment</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)</span><span class="o">/</span><span class="n">moment</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)))</span>

<span class="c1"># Wave period associated to mean frequency</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Wave period associated to mean frequency: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">moment</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)</span><span class="o">/</span><span class="n">moment</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)))</span>

<span class="c1"># Mean zero-crossing period</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Mean zero-crossing period:                &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">moment</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)</span><span class="o">/</span><span class="n">moment</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">))))</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output stream highlight-myst-ansi notranslate"><div class="highlight"><pre><span></span>Mean frequency :                          0.15673710449851574
Wave period associated to mean frequency: 6.380110205554229
Mean zero-crossing period:                5.819286177281177
</pre></div>
</div>
</div>
</div>
<br><p>\begin{equation}
\overline{T_{e}}=T_{-1}=2\pi\frac{m_{-1}}{m_{0}} \
v^{2}=\frac{m_{0}m_{2}}{m_{1}^{2}}-1
\end{equation}</p>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Mean energy period</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Mean energy period: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">moment</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)</span><span class="o">/</span><span class="n">moment</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)))</span>

<span class="c1"># Spectral width of Longuet-Higgins (1957)</span>
<span class="c1"># When de energy is concentrated in one single frequency, v = 0</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Spectral width:     &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">((</span><span class="n">moment</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)</span> <span class="o">*</span> <span class="n">moment</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)</span><span class="o">/</span><span class="n">moment</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)</span><span class="o">**</span><span class="mi">2</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output stream highlight-myst-ansi notranslate"><div class="highlight"><pre><span></span>Mean energy period: 7.501600226207497
Spectral width:     0.2020344942391914
</pre></div>
</div>
</div>
</div>
<br><p><strong>JONSWAP Goda (1985)</strong></p>
<p><span class="math notranslate nohighlight">\(S(f)=\alpha\cdot H_{s}^{2} \cdot T_{p}^{-4} \cdot f^{-5} \cdot e^{-1.25 \cdot (T_{p} \cdot f)^{-4}} \cdot \gamma^{e^{-(T_{p} \cdot f - 1)^{2}/(2 \cdot \sigma^{2})}}\)</span></p>
<p><span class="math notranslate nohighlight">\(\alpha \approxeq \frac{0.0624}{0.230+0.0336 \cdot \gamma - 0.185 \cdot (1.9 + \gamma)^{-1}}\)</span></p>
<p><span class="math notranslate nohighlight">\(
\sigma=\begin{cases}
\sigma_{a};  f \leq f_{p} \\ \sigma_{b}; f \geq f_{p}
\end{cases}
\)</span></p>
<p><span class="math notranslate nohighlight">\(\gamma = 1 to 7 (mean 3.3), \sigma_{a}\approxeq0.07, \sigma_{b}\approxeq 0.09\)</span></p>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Peak frequency: &#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">f</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">argmax</span><span class="p">(</span><span class="n">E</span><span class="p">)]))</span>
<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Peak period:    &#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="mi">1</span><span class="o">/</span><span class="n">f</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">argmax</span><span class="p">(</span><span class="n">E</span><span class="p">)]))</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output stream highlight-myst-ansi notranslate"><div class="highlight"><pre><span></span>Peak frequency: 0.1015625
Peak period:    9.846153846153847
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">gamma</span><span class="p">,</span> <span class="n">EJon</span> <span class="o">=</span> <span class="n">assess_jonwsap</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Best gamma JONSWAP fit: &#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">gamma</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output stream highlight-myst-ansi notranslate"><div class="highlight"><pre><span></span>Best gamma JONSWAP fit: 2
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Plot measured wave spectrum and theorecial JONSWAP shapes</span>
<span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">5</span><span class="p">,</span><span class="mi">5</span><span class="p">))</span>
<span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">,</span> <span class="n">c</span><span class="o">=</span><span class="s1">&#39;b&#39;</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Measured&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">f</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">EJon</span><span class="p">,</span> <span class="n">c</span><span class="o">=</span><span class="s1">&#39;r&#39;</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;JONSWAP gamma = </span><span class="si">{0}</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">gamma</span><span class="p">))</span>

<span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s1">&#39;frequency (Hz)&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s1">&#39;Densidad espectral (/Hz)&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s1">&#39;PSD (m²/Hz)&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>
<span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<img alt="../../../_images/BilbaoExt_36_0.png" src="../../../_images/BilbaoExt_36_0.png" />
</div>
</div>
</div>
<div class="section" id="a-3-short-term-statistics">
<h2>A.3 Short-term statistics<a class="headerlink" href="#a-3-short-term-statistics" title="Permalink to this headline">¶</a></h2>
<p>Definition of ‘waves’ in a time record of the surface elevation with upward zero-crossings</p>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">fs</span> <span class="o">=</span> <span class="mi">1</span>
<span class="n">T</span><span class="p">,</span> <span class="n">H</span> <span class="o">=</span> <span class="n">upcrossing</span><span class="p">(</span><span class="n">series</span><span class="p">,</span> <span class="n">fs</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">fig</span><span class="p">,</span> <span class="n">axs</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span><span class="mi">5</span><span class="p">),</span> <span class="n">sharex</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">axs</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">vlines</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">H</span><span class="p">)),</span> <span class="n">np</span><span class="o">.</span><span class="n">full</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">H</span><span class="p">),</span> <span class="mi">0</span><span class="p">),</span> <span class="n">H</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;orangered&#39;</span><span class="p">)</span>
<span class="n">axs</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">vlines</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">T</span><span class="p">)),</span> <span class="n">np</span><span class="o">.</span><span class="n">full</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">T</span><span class="p">),</span> <span class="mi">0</span><span class="p">),</span> <span class="n">T</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;slateblue&#39;</span><span class="p">)</span>
<span class="n">axs</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">H</span><span class="p">)),</span> <span class="n">H</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;orangered&#39;</span><span class="p">)</span>
<span class="n">axs</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">T</span><span class="p">)),</span> <span class="n">T</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;slateblue&#39;</span><span class="p">)</span>

<span class="n">axs</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s1">&#39;H (m)&#39;</span><span class="p">)</span>
<span class="n">axs</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s1">&#39;T (s)&#39;</span><span class="p">)</span>
<span class="n">axs</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s1">&#39;sequential waves in a sea-state (1-hour)&#39;</span><span class="p">)</span>

<span class="n">plt</span><span class="o">.</span><span class="n">xlim</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">100</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<img alt="../../../_images/BilbaoExt_40_0.png" src="../../../_images/BilbaoExt_40_0.png" />
</div>
</div>
<div class="section" id="statistical-parameters">
<h3>Statistical parameters<a class="headerlink" href="#statistical-parameters" title="Permalink to this headline">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">mean</span> <span class="pre">wave</span> <span class="pre">heigh</span></code> <span class="math notranslate nohighlight">\(\overline H\)</span></p>
<p><span class="math notranslate nohighlight">\(\overline H = \frac{1}{N} \sum_{i=1}^{N} H_{i}\)</span> <br> where i is the sequence number (in time) of the wave in the record</p>
<p><code class="docutils literal notranslate"><span class="pre">root-mean-square</span> <span class="pre">wave</span> <span class="pre">height</span></code> <span class="math notranslate nohighlight">\(H_{rms}\)</span></p>
<p><span class="math notranslate nohighlight">\(H_{rms}=(\frac{1}{N} \sum_{i=1}^{N} H_{i}^{2})^{1/2}\)</span></p>
<p><code class="docutils literal notranslate"><span class="pre">significant</span> <span class="pre">wave</span> <span class="pre">heigh</span></code> <span class="math notranslate nohighlight">\(H_{1/3}\)</span></p>
<p><span class="math notranslate nohighlight">\(H_{1/3}=\frac{1}{N/3} \sum_{j=1}^{N/3} H_{j}\)</span> <br> where j is the rank number of the wave, based on wave-heigh</p>
<p><code class="docutils literal notranslate"><span class="pre">mean</span> <span class="pre">of</span> <span class="pre">the</span> <span class="pre">highest</span> <span class="pre">one-tenth</span> <span class="pre">of</span> <span class="pre">waves</span></code> <span class="math notranslate nohighlight">\(H_{1/10}\)</span></p>
<p><span class="math notranslate nohighlight">\(H_{1/10}=\frac{1}{N/10} \sum_{j=1}^{N/10} H_{j}\)</span></p>
<p><code class="docutils literal notranslate"><span class="pre">mean</span> <span class="pre">zero-crossing</span> <span class="pre">wave</span> <span class="pre">period</span></code> <span class="math notranslate nohighlight">\(\overline T_{0}\)</span></p>
<p><span class="math notranslate nohighlight">\(\overline T_{0}=\frac{1}{N} \sum_{i=1}^{N} T_{0,i}\)</span></p>
<p><code class="docutils literal notranslate"><span class="pre">significant</span> <span class="pre">wave</span> <span class="pre">period</span></code> <span class="math notranslate nohighlight">\(T_{1/3}\)</span></p>
<p><span class="math notranslate nohighlight">\(T_{1/3}=\frac{1}{N/3} \sum_{j=1}^{N/3} T_{0,j}\)</span></p>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># mean wave heigh</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;mean wave heigh:                        &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">H</span><span class="p">)))</span>

<span class="c1"># root-mean-square wave height</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;root-mean-square wave height:           &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">rmsV</span><span class="p">(</span><span class="n">H</span><span class="p">)))</span>

<span class="c1"># significant wave heigh</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;significant wave heigh:                 &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">highestN_stats</span><span class="p">(</span><span class="n">H</span><span class="p">,</span> <span class="mi">3</span><span class="p">)))</span>

<span class="c1"># mean of the highest one-tenth of waves</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;mean of the highest one-tenth of waves: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">highestN_stats</span><span class="p">(</span><span class="n">H</span><span class="p">,</span> <span class="mi">10</span><span class="p">)))</span>

<span class="c1"># maximun wave heigh</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;maximun wave heigh:                     &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">H</span><span class="p">)))</span>

<span class="c1"># mean period</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;mean period:                            &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">T</span><span class="p">)))</span>

<span class="c1"># significant wave period</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;significant wave period:                &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">highestN_stats</span><span class="p">(</span><span class="n">T</span><span class="p">,</span> <span class="mi">3</span><span class="p">)))</span>

<span class="c1"># mean zero-crossing wave period</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;mean zero-crossing wave period:         &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">highestN_stats</span><span class="p">(</span><span class="n">T</span><span class="p">,</span> <span class="mi">10</span><span class="p">)))</span>

<span class="c1"># maximun wave period</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;maximun wave period:                    &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">T</span><span class="p">)))</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output stream highlight-myst-ansi notranslate"><div class="highlight"><pre><span></span>mean wave heigh:                        6.903592814371256
root-mean-square wave height:           10.743939187493275
significant wave heigh:                 10.770909090909093
mean of the highest one-tenth of waves: 12.7625
maximun wave heigh:                     15.600000000000001
mean period:                            6.017857142857146
significant wave period:                8.357142857142863
mean zero-crossing wave period:         10.312500000000014
maximun wave period:                    14.0
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="wave-heigh-distribution">
<h3>Wave Heigh Distribution<a class="headerlink" href="#wave-heigh-distribution" title="Permalink to this headline">¶</a></h3>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Rayleigh distribution of individual wave heighs</span>
<span class="n">fHs</span> <span class="o">=</span> <span class="p">[</span><span class="mf">4.01</span> <span class="o">*</span> <span class="p">(</span><span class="n">i</span><span class="o">/</span><span class="p">(</span><span class="mi">4</span> <span class="o">*</span> <span class="n">math</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">moment</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)))</span><span class="o">**</span><span class="mi">2</span><span class="p">)</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">exp</span><span class="p">(</span><span class="o">-</span><span class="mf">2.005</span> <span class="o">*</span> <span class="p">(</span><span class="n">i</span><span class="o">**</span><span class="mi">2</span><span class="o">/</span><span class="p">(</span><span class="mi">4</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">moment</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)))</span><span class="o">**</span><span class="mi">2</span><span class="p">))</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">H</span><span class="p">]</span>
<span class="n">FHs</span> <span class="o">=</span> <span class="p">[</span><span class="mi">1</span> <span class="o">-</span> <span class="n">np</span><span class="o">.</span><span class="n">exp</span><span class="p">(</span><span class="o">-</span><span class="mf">2.005</span> <span class="o">*</span> <span class="p">(</span><span class="n">i</span><span class="o">**</span><span class="mi">2</span><span class="o">/</span><span class="p">(</span><span class="mi">4</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">moment</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">E</span><span class="p">)))</span><span class="o">**</span><span class="mi">2</span><span class="p">))</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">H</span><span class="p">]</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Plot - sort arrays</span>
<span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">5</span><span class="p">,</span><span class="mi">5</span><span class="p">))</span>
<span class="n">plt</span><span class="o">.</span><span class="n">hist</span><span class="p">(</span><span class="n">H</span><span class="p">,</span> <span class="n">density</span> <span class="o">=</span> <span class="kc">True</span><span class="p">,</span> <span class="n">bins</span> <span class="o">=</span> <span class="mi">15</span><span class="p">,</span> <span class="n">rwidth</span><span class="o">=</span><span class="mf">0.95</span><span class="p">,</span> <span class="n">color</span> <span class="o">=</span> <span class="s2">&quot;slateblue&quot;</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="mf">0.5</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Hist. Hi&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sort</span><span class="p">(</span><span class="n">H</span><span class="p">),</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">fHs</span><span class="p">)[</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">H</span><span class="p">)</span><span class="o">.</span><span class="n">argsort</span><span class="p">()],</span> <span class="n">c</span> <span class="o">=</span> <span class="s2">&quot;k&quot;</span><span class="p">,</span> <span class="n">zorder</span> <span class="o">=</span> <span class="mi">10</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Rayleight distribution&#39;</span><span class="p">)</span>

<span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s1">&#39;H (m)&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s1">&#39;f(H)&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>
<span class="n">plt</span><span class="o">.</span><span class="n">xlim</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">nanmin</span><span class="p">(</span><span class="n">H</span><span class="p">),</span> <span class="n">np</span><span class="o">.</span><span class="n">nanmax</span><span class="p">(</span><span class="n">H</span><span class="p">))</span>
<span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<img alt="../../../_images/BilbaoExt_57_0.png" src="../../../_images/BilbaoExt_57_0.png" />
</div>
</div>
</div>
</div>
</div>

    <script type="text/x-thebe-config">
    {
        requestKernel: true,
        binderOptions: {
            repo: "binder-examples/jupyter-stacks-datascience",
            ref: "master",
        },
        codeMirrorConfig: {
            theme: "abcdef",
            mode: "python"
        },
        kernelOptions: {
            kernelName: "python3",
            path: "./ipynb/A_WaveAnalysis/A1_Observations"
        },
        predefinedOutput: true
    }
    </script>
    <script>kernelName = 'python3'</script>

              </div>
              
            
                <!-- Previous / next buttons -->
<div class='prev-next-area'> 
    <a class='left-prev' id="prev-link" href="MajuroAtoll.html" title="previous page">
        <i class="fas fa-angle-left"></i>
        <div class="prev-next-info">
            <p class="prev-next-subtitle">previous</p>
            <p class="prev-next-title">A. Wave analysis - Majuro Atoll (Republic of the Marshall Islands)</p>
        </div>
    </a>
    <a class='right-next' id="next-link" href="Terschelling.html" title="next page">
    <div class="prev-next-info">
        <p class="prev-next-subtitle">next</p>
        <p class="prev-next-title">A. Wave analysis - Terschelling (Netherlands)</p>
    </div>
    <i class="fas fa-angle-right"></i>
    </a>
</div>
            
        </div>
    </div>
    <footer class="footer">
  <p>
    
      Por GeoOcean, FLTQ - Universidad de Cantabria<br/>
    
        &copy; Derechos de autor 2021.<br/>
  </p>
</footer>
</main>


      </div>
    </div>
  
  <script src="../../../_static/js/index.be7d3bbb2ef33a8344ce.js"></script>

  </body>
</html>